<template>
  <div>
    <b-form-group class="m-0">
      <b-form-tags
        v-if="parameter.type === 'string+select+multiple+int'"
        v-model="$v[parameter.key].$model"
        :placeholder="parameter.placeholder || ''"
        :invalid-tag-text="
          parameter.options?.properties?.invalidTagText ||
          `Invalid ${parameter.title}`
        "
        :duplicate-tag-text="
          parameter.options?.properties?.duplicateTagText ||
          `Duplicate ${parameter.title}`
        "
        v-bind="addProperties(parameter, BFormTags)"
        :input-attrs="{ 'aria-describedby': 'tags-validation-help' }"
        :class="{ 'is-invalid': $v[parameter.key].$invalid }"
        :tag-validator="tagValidator"
        :disabled="disabled"
        @input="updateInput"
      ></b-form-tags>
    </b-form-group>
  </div>
</template>

<script>
import { BFormTags } from 'bootstrap-vue';
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    validations: {
      type: Function,
      default: () => ({}),
    },
    changeStateScenario: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      BFormTags: null,
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      [this.parameter.key]: [],
    };
  },
  validations() {
    return this.validations(this.parameter);
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
  },
  watch: {
    // Changes on the action
    param() {
      this[this.parameter.key] = this.getParamValue();
    },
  },
  mounted() {
    if (this.$v[this.parameter.key].$invalid) {
      this.changeStateScenario(this.parameter.key, true);
    }
  },
  beforeMount() {
    this.BFormTags = BFormTags;
    this[this.parameter.key] = this.getParamValue();
  },
  methods: {
    getParamValue() {
      if (this.param && this.param.value) {
        return this.param.value.split(',');
      }
      return [];
    },
    async updateInput(newValue) {
      if (this.disabled) return;
      if (!this.$v[this.parameter.key].$error) {
        let value = '';
        newValue.forEach((tag) => {
          value += tag + ',';
        });
        value = value.substring(0, value.length - 1);
        this.changeStateScenario(this.parameter.key, false);
        await this.updateValue(this.parameter.key, value);
      } else {
        this.changeStateScenario(this.parameter.key, true);
      }
    },
    tagValidator(tag) {
      return /^\d+$/.test(tag);
    },
  },
};
</script>
<style>
.b-form-tags-list .badge {
  background-color: #8d7ba8 !important;
}
</style>
